=== debian/changelog ===
openjph (0.9.0-3) unstable; urgency=medium

  * d/copyright Make sure to also remove simd version
  * d/symbols: Remove extra debug symbols

 -- Mathieu Malaterre <malat@debian.org>  Thu, 23 Jun 2022 10:22:24 +0200

openjph (0.9.0-2) unstable; urgency=medium

  * d/control: Bump Std-Vers to 4.6.1 no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Thu, 23 Jun 2022 08:48:59 +0200

openjph (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0
  * d/patches: Remove patches applied upstream
  * d/control: Bump to new SONAME 0.9
  * d/symbols: Add missing symbols

 -- Mathieu Malaterre <malat@debian.org>  Mon, 20 Jun 2022 17:28:40 +0200

openjph (0.8.2-5) unstable; urgency=medium

  * d/patches: Really fix file/64bits issue on 32bits arch

 -- Mathieu Malaterre <malat@debian.org>  Wed, 30 Mar 2022 10:00:21 +0200

openjph (0.8.2-4) unstable; urgency=medium

  * d/rules: Add explanation for missing test suite
  * d/patches: Remove bogus symbol patch
  * d/patches: Make sure to handle kFreeBSD also
  * d/patches: Make sure to use 64bits file API

 -- Mathieu Malaterre <malat@debian.org>  Mon, 14 Mar 2022 12:20:49 +0100

openjph (0.8.2-3) unstable; urgency=medium

  * d/rules: Make sure to clean generated manpages
  * d/control: Add missing help2man/doxygen dependencies

 -- Mathieu Malaterre <malat@debian.org>  Sat, 12 Mar 2022 18:04:40 +0100

openjph (0.8.2-2) unstable; urgency=medium

  * Upload to unstable
  * d/rules: Fix compilation on non-amd64 arch
  * d/symbols: Add missing symbols file
  * d/manpages: Fix typo in man pages
  * d/symbols: Remove all but amd64 symbols files
  * d/rules: Prefer ninja build system over make
  * d/control: Reduce cmake version dependency
  * d/rules: Remove test suite for now

 -- Mathieu Malaterre <malat@debian.org>  Sat, 12 Mar 2022 17:01:33 +0100

openjph (0.8.2-1) experimental; urgency=medium

  * Initial release (Closes: #1006929)

 -- Mathieu Malaterre <malat@debian.org>  Tue, 08 Mar 2022 12:54:54 +0100
