## openjph 0.18.2

=== debian/changelog ===
openjph (0.18.2-2) unstable; urgency=medium

  * Team upload.
  * new upstream not use OPENJPH_BUILD_TESTING env variable
    - d/rules: don't set BUILD_TESTING env variable
    - d/rules: remove override_dh_auto_test-arch target
    - d/rules: CMAKE_EXTRA_FLAGS remove -DBUILD_TESTING:BOOL= line
    - delete d/README.Debian
  * d/rules: use OJPH_DISABLE_SIMD instead of deprecated OJPH_DISABLE_INTEL_SIMD
  * d/copyright:
      - change License from BSD-2 to BSD-2-clause, let lrc happy
      - update-debian-copyright year info to 2025

 -- xiao sheng wen <atzlinux@debian.org>  Wed, 01 Jan 2025 10:23:27 +0800

openjph (0.18.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload.

 -- Boyuan Yang <byang@debian.org>  Tue, 31 Dec 2024 13:35:20 -0500

openjph (0.18.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * d/openjph-doc.docs: use docs/* to install whole docs directory
  * Bump to new SONAME 0.18
  * d/rules: DEB_BUILD_MAINT_OPTIONS add optimize=+lto, Closes: #1015566
  * delete old d/libopenjph0.10.symbols

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 17 Dec 2024 09:12:05 +0800

openjph (0.10.3-2) unstable; urgency=medium

  * Team upload.
  * d/control: remove Build-Depends-Indep field, add doxygen to Build-Depends

 -- xiao sheng wen <atzlinux@debian.org>  Thu, 12 Dec 2024 16:09:42 +0800

openjph (0.10.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Add salsa-ci file (routine-update)
  * d/control:
      - Build-Depends: delete ninja-build
      - binary package libopenjph0.9 rename to libopenjph0.10
  * rm d/libopenjph0.9.install d/libopenjph0.9.symbols.amd64
  * add d/libopenjph0.10.install
  * add d/libopenjph0.10.symbols
  * add d/clean
  * d/rules:
      - remove override_dh_clean-arch override_dh_clean-indep target
      - use execute_after_dh_auto_build target
      - use execute_before_dh_installman target
      - use "dh $@" only, remove "--buildsystem=cmake+ninja"
  * d/copyright:
      - update year info to 2024
      - delete Files-Excluded field, useless
      - add Upstream-Contact: Aous Naman <aous@unsw.edu.au>

 -- xiao sheng wen <atzlinux@sina.com>  Tue, 30 Jan 2024 17:27:05 +0800
