=== debian/control ===
--- 
+++ 
@@ -3,19 +3,18 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake (>= 3.10),
-               debhelper (>= 11),
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                help2man,
                libtiff-dev,
-               ninja-build
-Build-Depends-Indep: doxygen
-Standards-Version: 4.6.1
+               doxygen,
+Standards-Version: 4.7.0
 Homepage: https://github.com/aous72/OpenJPH
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjph.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
 Rules-Requires-Root: no
 
-Package: libopenjph0.9
+Package: libopenjph0.18
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -32,7 +31,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libopenjph0.9 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenjph0.18 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: HTJ2K image compression/decompression library (developer files)
  Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
