=== debian/changelog ===
openjph (0.21.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Feb 2025 16:46:02 -0500

openjph (0.21.0-1) unstable; urgency=medium

  * New upstream version 0.21.0
  * d/control: Bump SOVERSION to to 0.21
  * d/install: Install missing cmake files

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Feb 2025 08:36:49 +0100
