=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
 Rules-Requires-Root: no
 
-Package: libopenjph0.18
+Package: libopenjph0.21
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -31,7 +31,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libopenjph0.18 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenjph0.21 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: HTJ2K image compression/decompression library (developer files)
  Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
